/* expense.r */

/* Sculptor Demonstration Program */

/*****************************************************************************
	Maintain expense claims
*****************************************************************************/

!include <sculptor.h>
!include <printer.h>

!chargrid OFF

/****************************************************************************/

!define PROGNAME "expense.r"

/****************************************************************************/

!file EXPENSE "expense"

!define EXPENSE_PATH "localhost:c:/apps/expenses/expense"

!record SAVE_EXPENSE = EXPENSE

/****************************************************************************/

!record PRINT {
	StartDate,"From Date",i4/dn,"dD/MM/YYYY"
	EndDate,"To Date",i4/dn,"dD/MM/YYYY"
	Status,,a1,"u+"
	TotalGross,,n4.0/my,"#,###,##0.00"
	TotalVAT,,n4.0/my,"#,###,##0.00"
}

/****************************************************************************/

!record ExpenseDisplay {
	Date,"Date",i4/dn,"dD/MM/YYYY"
	GrossAmount,"Gross",n4.0/my,"#,###,##0.00"
	VATRate,"VAT%",n4.0/my,"##.##"
	VATAmount,"VAT",n4.0/my,"###,##0.00"
	Reimbursed,"Reimbursed",i4/dn,"dD/MM/YYYY"
	SerialNo,"Serial No.",i4,"#########"
	Details,"Details",a80
}

/****************************************************************************/

!temp Reimbursed,,i4/dn,"dD/MM/YYYY"
!temp WinEditCancelAll,,u1

/****************************************************************************/

-window wintask at 10,10 {
	max_width = 1000
	max_height = 550
	event = evWinTask
	style = WS_CAPTION | WS_CLOSEBUTTON | WS_MINBUTTON
	data_font = "MS Sans Serif@10"
	label_font = "MS Sans Serif@10"
	title = "CASH EXPENSE CLAIMS"
	winclass = "sc_expense_claims"

	+table tblExpense at 10,15 {
		display_object = ExpenseDisplay
		source_object = EXPENSE
		rows = 20
		max_line = 0
		width = 955
		event_enable = EV_DEFAULT | EV_RIGHT_MOUSE_UP
		event = evExpenseTable
		style = WS_NOROWLINES
		label_fgc = RGB_DARKBLUE
		mode = EM_MULTIPLE | EM_SYNC_SOURCE
	}

	+button pbAdd at 620,435 {
		label = "&Add Expense Claim"
		width = 140
		height = 28
		event = evAdd
	}

	+button pbClose at 870,435 {
		label = "Close"
		style = WS_CANCEL_BUTTON
		width = 70
		height = 28
		event = evClose
	}

	+text StaticText2 at 60,440 {
		label = "Not for payments made using company cheques and credit cards."
		label_fgc = RGB_DARKBLUE
	}

	+text StaticText1 at 60,420 {
		label = "For personal payments that need to be reimbursed."
		label_fgc = RGB_DARKBLUE
	}

	+text StaticText3 at 60,460 {
		label = "If an expense contains VAT and non-VAT items, enter separate claims."
		label_fgc = RGB_DARKBLUE
	}

	menu mMain {

		menuitem miPrint {
			label = "Print"
			select = evPrint
		}
	}

	menu mPopup {
		style = WS_POPUP

		menuitem miEdit {
			style = WS_DISABLED
			label = "Edit"
			select = evEdit
		}

		menuitem miDelete {
			style = WS_DISABLED
			label = "Delete"
			select = evDelete
		}

		menuline

		menuitem miSetPaid {
			style = WS_DISABLED
			label = "Set Date Reimbursed"
			select = evSetPaid
		}

		menuitem miSetUnpaid {
			style = WS_DISABLED
			label = "Clear Date Reimbursed"
			select = evSetUnpaid
		}
	}
}

/****************************************************************************/

-window WinEdit at 121,121 {
	max_width = 780
	max_height = 259
	event = evWinEdit
	parent = wintask
	style = WS_INVISIBLE | WS_CLOSEBUTTON | WS_CAPTION | WS_OWNED
	data_font = "MS Sans Serif@10"
	label_font = "MS Sans Serif@10"
	title = "EDIT EXPENSE CLAIM"

	textbox group tgData {

		+textbox tbDate at 102,25 {
			field = EXPENSE.Date
			format = "dD/MM/YYYY"
		}

		+textbox tbGrossAmount at 102,57 {
			field = EXPENSE.GrossAmount
		}

		+textbox tbVATRate at 300,57 {
			field = EXPENSE.VATRate
			validate = valVATRate
		}

		+textbox tbVATAmount at 470,57 {
			field = EXPENSE.VATAmount
			validate = valVATAmount
		}

		+textbox tbDetails at 102,89 {
			field = EXPENSE.Details
		}

		+textbox tbReimbursed at 102,121 {
			field = EXPENSE.Reimbursed
			format = "dD/MM/YYYY"
		}
	}

	button group bgControl {

		+button pbSave at 240,168 {
			label = "Save"
			style = WS_DEFAULT_BUTTON
			width = 72
			height = 28
			event = evWinEditSave
		}

		+button pbCancel at 360,168 {
			label = "Cancel"
			style = WS_CANCEL_BUTTON
			width = 72
			height = 28
			event = evWinEditCancel
		}

		+button pbCancelAll at 480,168 {
			label = "Cancel All"
			width = 80
			height = 28
			event = evWinEditCancelAll
		}
	}
}

/****************************************************************************/

-window WinPaid at 290,164 {
	max_width = 290
	max_height = 165
	event = evWinPaid
	parent = wintask
	style = WS_INVISIBLE | WS_CLOSEBUTTON | WS_CAPTION | WS_OWNED
	data_font = "MS Sans Serif@10"
	label_font = "MS Sans Serif@10"
	title = "SET DATE REIMBURSED"

	+textbox tbReimbursed at 120,32 {
		field = tmp.Reimbursed
	}

	button group bgControl {

		+button pbSetDate at 50,80 {
			label = "Set Date"
			style = WS_DEFAULT_BUTTON
			width = 72
			height = 28
			event = evWinPaidSetDate
		}

		+button pbCancel at 170,80 {
			label = "Cancel"
			style = WS_CANCEL_BUTTON
			width = 72
			height = 28
			event = evWinPaidCancel
		}
	}
}

/****************************************************************************/

-window WinPrint at 249,122 {
	max_width = 395
	max_height = 285
	event = evWinPrint
	parent = wintask
	style = WS_INVISIBLE | WS_CLOSEBUTTON | WS_CAPTION | WS_OWNED
	data_font = "MS Sans Serif@10"
	label_font = "MS Sans Serif@10"
	title = "PRINT OPTIONS"

	+graphic Graphic1 at 114,99 {
		type = GT_RECTANGLE
		width = 170
		height = 90
		title = " Status "
	}

	textbox group tgData {

		+textbox tbStartDate at 130,22 {
			field = PRINT.StartDate
			format = "dD/MM/YYYY"
		}

		+textbox tbEndDate at 130,56 {
			field = PRINT.EndDate
			format = "dD/MM/YYYY"
		}
	}

	+text StaticText1 at 228,24 {
		label = "Blank = from start"
	}

	+text StaticText2 at 228,58 {
		label = "Blank = to end"
	}

	radio group rgStatus {

		+button rbAll at 138,113 {
			label = "All"
			field = PRINT.Status
			checked_value = "A"
		}

		+button rbReimbursed at 138,136 {
			label = "Reimbursed"
			field = PRINT.Status
			checked_value = "R"
		}

		+button rbNotReimbursed at 138,159 {
			label = "Not Reimbursed"
			field = PRINT.Status
			checked_value = "N"
		}
	}

	button group bgControl {

		+button pbPreview at 60,210 {
			label = "Preview"
			width = 72
			height = 28
			event = evWinPrintPreview
		}

		+button pbPrint at 160,210 {
			label = "Print"
			style = WS_DEFAULT_BUTTON
			width = 72
			height = 28
			event = evWinPrintPrint
		}

		+button pbClose at 260,210 {
			label = "Close"
			style = WS_CANCEL_BUTTON
			width = 72
			height = 28
			event = evWinPrintClose
		}
	}
}

/*****************************************************************************
	Main code
*****************************************************************************/

	if (activate_app(wintask->winclass, NULL) == OKAY) {
		sys.RestoreFocus = OFF
		exit
	}

	EXPENSE->batch_read = ON
	openfile EXPENSE name=EXPENSE_PATH update nsf=IGNORE

	if (sys.Traps & TRAP_NSF) {
		openfile EXPENSE name=EXPENSE_PATH create nsf=IGNORE
	}

	create wintask, WinEdit, WinPaid, WinPrint
	WinPrint.rgStatus.rbAll->checked = TRUE
	open wintask.mMain

	dialog
	exit

/*****************************************************************************
	Functions for wintask
*****************************************************************************/

!function evAdd(EventCode) {

	switch (EventCode) {

	case == EV_BUTTON_CLICKED:
		clear EXPENSE
		WinEdit->title = "ADD EXPENSE CLAIM"
		display WinEdit
		hide WinEdit.bgControl.pbCancelAll
		show WinEdit

		while (TRUE) {
			dialog WinEdit cancel=ADD_EXPENSE_CANCEL
			if (fInsertExpense() == OKAY) break
		}

		set_selected(tblExpense, 0, FALSE)
		table_set_selected_key(tblExpense, TRUE)
		display tblExpense

ADD_EXPENSE_CANCEL:
		hide WinEdit
		break
	}
}

/****************************************************************************/

!function evClose(EventCode) {

	switch (EventCode) {

	case == EV_BUTTON_CLICKED:
		return CLOSE_DIALOG
	}
}

/****************************************************************************/

!function evDelete(EventCode) {
!temp Result,,i2

	switch (EventCode) {

	case == EV_MENU:
		Result = table_first_selected_key(tblExpense)
		if (Result != OKAY) break

		fSetPromptPosn()

		prompt "Delete selected claims? " \
				button=" Yes " button=" No  ", BREAK

		while (Result == OKAY) {
			read EXPENSE nsr=IGNORE
			delete EXPENSE nrs=IGNORE
			table_set_selected_key(tblExpense, FALSE)
			Result = table_next_selected_key(tblExpense)
		}

		display tblExpense
		break
	}
}

/****************************************************************************/

!function evEdit(EventCode) {
!temp Result,,i2

	switch (EventCode) {

	case == EV_MENU:
		tmp.WinEditCancelAll = FALSE
		Result = table_first_selected_key(tblExpense)

		while (Result == OKAY) {
			fEditExpense()
			if (tmp.WinEditCancelAll) break
			Result = table_next_selected_key(tblExpense)
		}

		break
	}
}

/****************************************************************************/

!function evExpenseTable(EventCode, Object, Line, State, Xctl, Yctl, Xwin, Ywin) {

	switch (EventCode) {

	case == EV_DOUBLE_CLICK:
		evEdit(EV_MENU)
		break

	case == EV_RIGHT_MOUSE_UP:
		if (Line) {
			if (table_first_selected_key(Object) != OKAY) {
				set_selected(Object, Line, TRUE)
			}
			if (table_first_selected_key(Object) == OKAY) {
				mPopup.miEdit->style = mPopup.miEdit->style & ~WS_DISABLED
				mPopup.miDelete->style = mPopup.miDelete->style & ~WS_DISABLED
				mPopup.miSetPaid->style = mPopup.miSetPaid->style & ~WS_DISABLED
				mPopup.miSetUnpaid->style = mPopup.miSetUnpaid->style & ~WS_DISABLED
				move cursor to Xwin, Ywin in wintask
				open mPopup
			}
		}
		break

	case == EV_SELECT:
		if (State) break
		/* Drop through to EV_UNSELALL */

	case == EV_UNSELALL:
		mPopup.miEdit->style = mPopup.miEdit->style | WS_DISABLED
		mPopup.miDelete->style = mPopup.miDelete->style | WS_DISABLED
		mPopup.miSetPaid->style = mPopup.miSetPaid->style | WS_DISABLED
		mPopup.miSetUnpaid->style = mPopup.miSetUnpaid->style | WS_DISABLED
		break
	}
}

/****************************************************************************/

!function evPrint(EventCode) {

	switch (EventCode) {

	case == EV_MENU:
		clear PRINT
		show WinPrint
		dialog WinPrint
		hide WinPrint
		break
	}
}

/****************************************************************************/

!function evSetPaid(EventCode) {
!temp Result,,i2

	switch (EventCode) {

	case == EV_MENU:
		if (tmp.Reimbursed == 0) {
			tmp.Reimbursed = sys.Date
		}
		display WinPaid
		show WinPaid
		dialog WinPaid
		hide WinPaid
		break
	}
}

/****************************************************************************/

!function evSetUnpaid(EventCode) {
!temp Result,,i2

	switch (EventCode) {

	case == EV_MENU:
		Result = table_first_selected_key(tblExpense)
		if (Result != OKAY) break

		fSetPromptPosn()

		prompt "Clear date reimbursed? " \
				button=" Yes " button=" No  ", BREAK

		while (Result == OKAY) {
			read EXPENSE nsr=IGNORE
			EXPENSE.Reimbursed = 0
			write EXPENSE nrs=IGNORE
			table_set_selected_key(tblExpense, FALSE)
			Result = table_next_selected_key(tblExpense)
		}

		display tblExpense
		break
	}
}

/****************************************************************************/

!function evWinTask(EventCode) {

	switch (EventCode) {

	case == EV_CLOSE:
		exit
	}
}

/*****************************************************************************
	Functions for WinEdit
*****************************************************************************/

!function evWinEdit(EventCode) {

	switch (EventCode) {

	case == EV_CLOSE:
		return CANCEL_DIALOG
	}
}

/****************************************************************************/

!function evWinEditCancel(EventCode) {

	switch (EventCode) {

	case == EV_BUTTON_CLICKED:
		tmp.WinEditCancelAll = FALSE
		return CANCEL_DIALOG
	}
}

/****************************************************************************/

!function evWinEditCancelAll(EventCode) {

	switch (EventCode) {

	case == EV_BUTTON_CLICKED:
		tmp.WinEditCancelAll = TRUE
		return CANCEL_DIALOG
	}
}

/****************************************************************************/

!function evWinEditSave(EventCode) {

	switch (EventCode) {

	case == EV_BUTTON_CLICKED:
		return CLOSE_DIALOG
	}
}

/****************************************************************************/

!function valVATRate(EventCode) {

	switch (EventCode) {

	case == EV_VALIDATE:
		if (EXPENSE.VATRate) {
			sys.Rounding = ON
			EXPENSE.VATAmount = (EXPENSE.GrossAmount * EXPENSE.VATRate) / (EXPENSE.VATRate + 10000)
		} else {
			EXPENSE.VATAmount = 0
		}
		display WinEdit.tgData.tbVATAmount
		break
	}
}

/****************************************************************************/

!function valVATAmount(EventCode) {

	switch (EventCode) {

	case == EV_VALIDATE:
		if (EXPENSE.VATAmount) {
			sys.Rounding = ON
			EXPENSE.VATRate = ((100 * EXPENSE.VATAmount) / (EXPENSE.GrossAmount - EXPENSE.VATAmount)) * 100
		} else {
			EXPENSE.VATRate = 0
		}
		display WinEdit.tgData.tbVATRate
		break
	}
}

/*****************************************************************************
	Functions for WinPaid
*****************************************************************************/

!function evWinPaid(EventCode) {

	switch (EventCode) {

	case == EV_CLOSE:
		return CANCEL_DIALOG
	}
}

/****************************************************************************/

!function evWinPaidCancel(EventCode) {

	switch (EventCode) {

	case == EV_BUTTON_CLICKED:
		return CANCEL_DIALOG
	}
}

/****************************************************************************/

!function evWinPaidSetDate(EventCode) {
!temp Result,,i2

	switch (EventCode) {

	case == EV_BUTTON_CLICKED:
		Result = table_first_selected_key(tblExpense)

		while (Result == OKAY) {
			read EXPENSE nsr=IGNORE
			EXPENSE.Reimbursed = tmp.Reimbursed
			write EXPENSE nrs=IGNORE
			table_set_selected_key(tblExpense, FALSE)
			Result = table_next_selected_key(tblExpense)
		}

		display tblExpense
		return CLOSE_DIALOG
	}
}

/*****************************************************************************
	Functions for WinPrint
*****************************************************************************/

!function evWinPrint(EventCode) {

	switch (EventCode) {

	case == EV_CLOSE:
		return CANCEL_DIALOG
	}
}

/****************************************************************************/

!function evWinPrintClose(EventCode) {

	switch (EventCode) {

	case == EV_BUTTON_CLICKED:
		return CANCEL_DIALOG
	}
}

/****************************************************************************/

!function evWinPrintPreview(EventCode) {

	switch (EventCode) {

	case == EV_BUTTON_CLICKED:
		fPrintExpenseClaims("V")
		break
	}
}

/****************************************************************************/

!function evWinPrintPrint(EventCode) {

	switch (EventCode) {

	case == EV_BUTTON_CLICKED:
		fPrintExpenseClaims("P")
		break
	}
}

/*****************************************************************************
	Edit expense claim
*****************************************************************************/

!function fEditExpense() {

	read EXPENSE nsr=IGNORE

	if (sys.Traps & TRAP_NSR) {
		table_set_selected_key(tblExpense, FALSE)
		display tblExpense
		return
	}

	WinEdit->title = "EDIT EXPENSE CLAIM"
	display WinEdit
	show WinEdit.bgControl.pbCancelAll
	show WinEdit

	while (TRUE) {
		dialog WinEdit cancel=EDIT_EXPENSE_CANCEL
		if (fWriteExpense() == OKAY) break
	}

	display tblExpense

EDIT_EXPENSE_CANCEL:
	unlock EXPENSE
	hide WinEdit
}

/*****************************************************************************
	Write updated expense claim
*****************************************************************************/

!function fWriteExpense() {

	if (fCheckExpenseRecord() == ERROR) return ERROR

	write EXPENSE nrs=IGNORE re=IGNORE
	if (sys.Traps == 0) return OKAY

	fInsertExpenseRecord()

	return OKAY
}

/*****************************************************************************
	Insert new expense claim
*****************************************************************************/

!function fInsertExpense() {

	if (fCheckExpenseRecord() == ERROR) return ERROR

	fInsertExpenseRecord()

	return OKAY
}

/****************************************************************************/

!function fCheckExpenseRecord() {

	if (EXPENSE.Date == 0) {
		error "Expense date cannot be blank"
		return ERROR
	}

	if (EXPENSE.GrossAmount == 0) {
		error "Gross amount cannot be blank"
		return ERROR
	}

	return OKAY
}

/****************************************************************************/

!function fInsertExpenseRecord() {

	wind EXPENSE
	prevkey EXPENSE nsr=IGNORE

	if (sys.Traps & TRAP_NSR) {
		EXPENSE.SerialNo = 0
	}

	while (TRUE) {
		EXPENSE.SerialNo++
		insert EXPENSE re=IGNORE
		if (sys.Traps == 0) break
	}
}

/*****************************************************************************
	Print expense claims
*****************************************************************************/

!function fPrintExpenseClaims(Option) {

	SAVE_EXPENSE = EXPENSE

	/* Open file in read mode to take advantage of batch reads */
	openfile EXPENSE name=EXPENSE_PATH read

	if (Option = "V") {
		run report repPrintExpenseClaims ppf="Arial"
	} else {
		run report repPrintExpenseClaims to "PrintManager" ppf="Arial"
	}

	/* Reopen file in update mode */
	openfile EXPENSE name=EXPENSE_PATH update

	/* Reset the file position */
	EXPENSE = SAVE_EXPENSE
	readkey EXPENSE traps=IGNORE
}

/*****************************************************************************
	Set prompt window position
*****************************************************************************/

!function fSetPromptPosn() {

	winprompt->xcreate = wintask->xposn + 300
	winprompt->ycreate = wintask->yposn + 200
}

/*****************************************************************************
	Reports
*****************************************************************************/

!report repPrintExpenseClaims {

!drive EXPENSE index=ExpenseByDate

/****************************************************************************/

!init {
	PRINT.TotalGross = 0
	PRINT.TotalVAT = 0
	SAVE_EXPENSE = EXPENSE
	setfont("Arial", 8, FONT_NORMAL)
	sys.Gap = 1
	sys.LeftMargin = 6
	sys.LineHeight = sys.CharHeight
}

/****************************************************************************/

!heading {
	print	PSC_ENHANCED; PSC_UNDERLINE;

	print "EXPENSE CLAIMS";

	if (PRINT.StartDate) {
		print	" from "; PRINT.StartDate;
	}

	if (PRINT.EndDate) {
		print	" to "; PRINT.EndDate;
	}

	print	PSC_END_UNDERLINE; PSC_NORMAL; nsp(4); PSC_ENHANCED; \
			"(printed at "; sys.Time; " on "; sys.Date:"dD/MM/YYYY"; ")"; \
			PSC_NORMAL; nsp(4); \
			"Page: "; PSC_ENHANCED; tostr(sys.PageNumber); \
			PSC_NORMAL

	print

	printh	PSC_UNDERLINE; *EXPENSE.Date; PSC_END_UNDERLINE, \
			PSC_UNDERLINE; *EXPENSE.GrossAmount; PSC_END_UNDERLINE, \
			PSC_UNDERLINE; *EXPENSE.VATAmount; PSC_END_UNDERLINE, \
			PSC_UNDERLINE; *EXPENSE.Reimbursed; PSC_END_UNDERLINE, \
			PSC_UNDERLINE; *EXPENSE.SerialNo; PSC_END_UNDERLINE; spc(2); \
			PSC_UNDERLINE; *EXPENSE.Details; PSC_END_UNDERLINE

	print
}

/****************************************************************************/

!final {
	print
	printh	[EXPENSE.Date], \
			PSC_UNDERLINE; \
			PRINT.TotalGross, \
			PRINT.TotalVAT; \
			PSC_END_UNDERLINE
}

/****************************************************************************/

	if (PRINT.EndDate and EXPENSE.Date > PRINT.EndDate) end report

	if (PRINT.StartDate and EXPENSE.Date < PRINT.StartDate) end

	switch (PRINT.Status) {
	case == "R":
		if (EXPENSE.Reimbursed == 0) end
		break
	case == "N":
		if (EXPENSE.Reimbursed) end
		break
	}

	need 3

	printh	EXPENSE.Date, \
			EXPENSE.GrossAmount, \
			EXPENSE.VATAmount, \
			EXPENSE.Reimbursed, \
			EXPENSE.SerialNo; spc(2); \
			fit(EXPENSE.Details)

	PRINT.TotalVAT = PRINT.TotalVAT + EXPENSE.VATAmount
	PRINT.TotalGross = PRINT.TotalGross + EXPENSE.GrossAmount

	end
}

/****************************************************************************/
