/* mileage.r */

/* Sculptor Demonstration Program */

/*****************************************************************************
	Maintain mileage claims
*****************************************************************************/

!include <sculptor.h>
!include <printer.h>

!chargrid OFF

/****************************************************************************/

!define PROGNAME "mileage.r"

/****************************************************************************/

!file CONTROL "control"
!file MILEAGE "mileage"

!define CONTROL_PATH "localhost:c:/apps/expenses/control"
!define MILEAGE_PATH "localhost:c:/apps/expenses/mileage"

!record SAVE_MILEAGE = MILEAGE

/****************************************************************************/

!record PRINT {
	StartDate,"From End Date",i4/dn,"dD/MM/YYYY"
	EndDate,"To End Date",i4/dn,"dD/MM/YYYY"
	Status,,a1,"u+"
	TotalMileage,,i4
}

/****************************************************************************/

!record MileageDisplay {
	StartDate,"Start Date",i4/dn,"dD/MM/YYYY"
	EndDate,"End Date",i4/dn,"dD/MM/YYYY"
	Cat,"Cat",a1
	RegNo,"Reg No",a8
	Mileage,"Mileage",i4,"######"
	DatePaid,"Date Paid",i4/dn,"dD/MM/YYYY"
	Details,"Details",a80
}

/****************************************************************************/

!temp DatePaid,,i4/dn,"dD/MM/YYYY"
!temp WinEditCancelAll,,u1

/****************************************************************************/

-window wintask at 10,9 {
	max_width = 1000
	max_height = 562
	event = evWinTask
	style = WS_CAPTION | WS_CLOSEBUTTON | WS_MINBUTTON
	data_font = "MS Sans Serif@10"
	label_font = "MS Sans Serif@10"
	title = "MILEAGE CLAIMS"
	winclass = "sc_mileage_claims"

	+table tblMileage at 10,35 {
		display_object = MileageDisplay
		source_object = MILEAGE
		rows = 20
		max_line = 0
		width = 955
		event_enable = EV_DEFAULT | EV_RIGHT_MOUSE_UP
		event = evMileageTable
		style = WS_NOROWLINES
		label_fgc = RGB_DARKBLUE
		mode = EM_MULTIPLE | EM_SYNC_SOURCE
	}

	+button pbAdd at 600,450 {
		label = "&Add Mileage Claim"
		width = 140
		height = 28
		event = evAdd
	}

	+button pbClose at 860,450 {
		label = "Close"
		style = WS_CANCEL_BUTTON
		width = 70
		height = 28
		event = evClose
	}

	+text StaticText1 at 195,12 {
		label = "B=Bicycle, C=Car, M=Motorbike"
		label_fgc = RGB_DARKBLUE
	}

	menu mMain {

		menuitem miPrint {
			label = "Print"
			select = evPrint
		}
	}

	menu mPopup {
		style = WS_POPUP

		menuitem miEdit {
			style = WS_DISABLED
			label = "Edit"
			select = evEdit
		}

		menuitem miDelete {
			style = WS_DISABLED
			label = "Delete"
			select = evDelete
		}

		menuline

		menuitem miSetPaid {
			style = WS_DISABLED
			label = "Set Date Paid"
			select = evSetPaid
		}

		menuitem miSetUnpaid {
			style = WS_DISABLED
			label = "Set Unpaid"
			select = evSetUnpaid
		}
	}
}

/****************************************************************************/

-window WinEdit at 128,117 {
	max_width = 769
	max_height = 299
	event = evWinEdit
	parent = wintask
	style = WS_INVISIBLE | WS_CLOSEBUTTON | WS_CAPTION | WS_OWNED
	data_font = "MS Sans Serif@10"
	label_font = "MS Sans Serif@10"
	title = "EDIT MILEAGE CLAIM"

	+graphic Graphic1 at 280,29 {
		type = GT_RECTANGLE
		width = 136
		height = 91
	}

	textbox group tgData {

		+textbox tbStartDate at 92,20 {
			field = MILEAGE.StartDate
			format = "dD/MM/YYYY"
			event = evMileageStartDate
		}

		+textbox tbEndDate at 92,52 {
			field = MILEAGE.EndDate
			format = "dD/MM/YYYY"
		}

		+textbox tbRegNo at 92,84 {
			field = MILEAGE.RegNo
		}

		+textbox tbMileage at 92,116 {
			field = MILEAGE.Mileage
		}

		+textbox tbDetails at 92,148 {
			field = MILEAGE.Details
		}

		+textbox tbDatePaid at 92,180 {
			field = MILEAGE.DatePaid
			format = "dD/MM/YYYY"
		}
	}

	radio group rgCat {

		+button rbCar at 305,40 {
			label = " Car"
			field = MILEAGE.Cat
			checked_value = "C"
		}

		+button rbMotorbike at 305,66 {
			label = " Motorbike"
			field = MILEAGE.Cat
			checked_value = "M"
		}

		+button rbBicycle at 305,92 {
			label = " Bicycle"
			field = MILEAGE.Cat
			checked_value = "B"
		}
	}

	button group bgControl {

		+button pbSave at 250,218 {
			label = "Save"
			style = WS_DEFAULT_BUTTON
			width = 72
			height = 28
			event = evWinEditSave
		}

		+button pbCancel at 360,218 {
			label = "Cancel"
			style = WS_CANCEL_BUTTON
			width = 72
			height = 28
			event = evWinEditCancel
		}

		+button pbCancelAll at 470,218 {
			label = "Cancel All"
			width = 80
			height = 28
			event = evWinEditCancelAll
		}
	}
}

/****************************************************************************/

-window WinPaid at 285,162 {
	max_width = 290
	max_height = 165
	event = evWinPaid
	parent = wintask
	style = WS_INVISIBLE | WS_CLOSEBUTTON | WS_CAPTION | WS_OWNED
	data_font = "MS Sans Serif@10"
	label_font = "MS Sans Serif@10"
	title = "SET DATE PAID"

	+textbox tbDatePaid at 120,32 {
		field = tmp.DatePaid
	}

	button group bgControl {

		+button pbSetDate at 50,80 {
			label = "Set Date"
			style = WS_DEFAULT_BUTTON
			width = 72
			height = 28
			event = evWinPaidSetDate
		}

		+button pbCancel at 170,80 {
			label = "Cancel"
			style = WS_CANCEL_BUTTON
			width = 72
			height = 28
			event = evWinPaidCancel
		}
	}
}

/****************************************************************************/

-window WinPrint at 249,118 {
	max_width = 395
	max_height = 285
	event = evWinPrint
	parent = wintask
	style = WS_INVISIBLE | WS_CLOSEBUTTON | WS_CAPTION | WS_OWNED
	data_font = "MS Sans Serif@10"
	label_font = "MS Sans Serif@10"
	title = "PRINT OPTIONS"

	+graphic Graphic1 at 47,102 {
		type = GT_RECTANGLE
		width = 150
		height = 90
		title = " Categories "
	}

	+graphic Graphic2 at 195,102 {
		type = GT_RECTANGLE
		width = 150
		height = 90
		title = " Status "
	}

	textbox group tgData {

		+textbox tbStartDate at 140,22 {
			field = PRINT.StartDate
			format = "dD/MM/YYYY"
		}

		+textbox tbEndDate at 140,56 {
			field = PRINT.EndDate
			format = "dD/MM/YYYY"
		}
	}

	+text StaticText1 at 238,24 {
		label = "Blank = from start"
	}

	+text StaticText2 at 238,58 {
		label = "Blank = to end"
	}

	checkbox group cgCat {

		+button cbCars at 74,116 {
			label = "Cars"
		}

		+button cbMotorbikes at 74,139 {
			label = "Motorbikes"
		}

		+button cbBicycles at 74,162 {
			label = "Bicycles"
		}
	}

	radio group rgStatus {

		+button rbAll at 239,116 {
			label = "All"
			field = PRINT.Status
			checked_value = "A"
		}

		+button rbPaid at 239,139 {
			label = "Paid"
			field = PRINT.Status
			checked_value = "P"
		}

		+button rbUnpaid at 239,162 {
			label = "Unpaid"
			field = PRINT.Status
			checked_value = "U"
		}
	}

	button group bgControl {

		+button pbPreview at 60,212 {
			label = "Preview"
			width = 72
			height = 28
			event = evWinPrintPreview
		}

		+button pbPrint at 160,212 {
			label = "Print"
			style = WS_DEFAULT_BUTTON
			width = 72
			height = 28
			event = evWinPrintPrint
		}

		+button pbClose at 260,212 {
			label = "Close"
			style = WS_CANCEL_BUTTON
			width = 72
			height = 28
			event = evWinPrintClose
		}
	}
}

/*****************************************************************************
	Main code
*****************************************************************************/

	if (activate_app(wintask->winclass, NULL) == OKAY) {
		sys.RestoreFocus = OFF
		exit
	}

	openfile CONTROL name=CONTROL_PATH update nsf=IGNORE

	if (sys.Traps & TRAP_NSF) {
		openfile CONTROL name=CONTROL_PATH create nsf=IGNORE
	}

	MILEAGE->batch_read = ON
	openfile MILEAGE name=MILEAGE_PATH update nsf=IGNORE

	if (sys.Traps & TRAP_NSF) {
		openfile MILEAGE name=MILEAGE_PATH create nsf=IGNORE
	}

	readu CONTROL key=1 nsr=IGNORE

	if (sys.Traps & TRAP_NSR) {
		CONTROL.Key = 1
		CONTROL.MileageCat = "C"
		insert CONTROL re=IGNORE
	}

	create wintask, WinEdit, WinPaid, WinPrint
	WinPrint.cgCat.cbCars->checked = TRUE
	WinPrint.cgCat.cbMotorbikes->checked = TRUE
	WinPrint.cgCat.cbBicycles->checked = TRUE
	WinPrint.rgStatus.rbAll->checked = TRUE
	open wintask.mMain

	dialog
	exit

/*****************************************************************************
	Functions for wintask
*****************************************************************************/

!function evAdd(EventCode) {

	switch (EventCode) {

	case == EV_BUTTON_CLICKED:
		clear MILEAGE
		MILEAGE.Cat = CONTROL.MileageCat
		MILEAGE.RegNo = CONTROL.RegNo
		WinEdit->title = "ADD MILEAGE CLAIM"
		display WinEdit
		hide WinEdit.bgControl.pbCancelAll
		show WinEdit

		while (TRUE) {
			dialog WinEdit cancel=ADD_MILEAGE_CANCEL
			if (fInsertMileage() == OKAY) break
		}

		read CONTROL key=1 nsr=IGNORE
		CONTROL.MileageCat = MILEAGE.Cat
		CONTROL.RegNo = MILEAGE.RegNo
		write CONTROL nrs=IGNORE

		if (sys.Traps & TRAP_NRS) {
			CONTROL.Key = 1
			insert CONTROL re=IGNORE
		}

		set_selected(tblMileage, 0, FALSE)
		table_set_selected_key(tblMileage, TRUE)
		display tblMileage

ADD_MILEAGE_CANCEL:
		hide WinEdit
		break
	}
}

/****************************************************************************/

!function evClose(EventCode) {

	switch (EventCode) {

	case == EV_BUTTON_CLICKED:
		return CLOSE_DIALOG
	}
}

/****************************************************************************/

!function evDelete(EventCode) {
!temp Result,,i2

	switch (EventCode) {

	case == EV_MENU:
		Result = table_first_selected_key(tblMileage)
		if (Result != OKAY) break

		fSetPromptPosn()

		prompt "Delete selected claims? " \
				button=" Yes " button=" No  ", BREAK

		while (Result == OKAY) {
			read MILEAGE nsr=IGNORE
			delete MILEAGE nrs=IGNORE
			table_set_selected_key(tblMileage, FALSE)
			Result = table_next_selected_key(tblMileage)
		}

		display tblMileage
		break
	}
}

/****************************************************************************/

!function evEdit(EventCode) {
!temp Result,,i2

	switch (EventCode) {

	case == EV_MENU:
		tmp.WinEditCancelAll = FALSE
		Result = table_first_selected_key(tblMileage)

		while (Result == OKAY) {
			fEditMileage()
			if (tmp.WinEditCancelAll) break
			Result = table_next_selected_key(tblMileage)
		}

		break
	}
}

/****************************************************************************/

!function evMileageStartDate(EventCode) {

	switch (EventCode) {

	case == EV_LOSE_FOCUS:
		if (MILEAGE.EndDate == 0 and MILEAGE.StartDate != 0) {
			MILEAGE.EndDate = MILEAGE.StartDate
			display WinEdit.tgData.tbEndDate
			if (MILEAGE.RegNo) {
				setfocus WinEdit.tgData.tbMileage
			} else {
				setfocus WinEdit.tgData.tbRegNo
			}
		}
		break
	}
}

/****************************************************************************/

!function evMileageTable(EventCode, Object, Line, State, Xctl, Yctl, Xwin, Ywin) {

	switch (EventCode) {

	case == EV_DOUBLE_CLICK:
		evEdit(EV_MENU)
		break

	case == EV_RIGHT_MOUSE_UP:
		if (Line) {
			if (table_first_selected_key(Object) != OKAY) {
				set_selected(Object, Line, TRUE)
			}
			if (table_first_selected_key(Object) == OKAY) {
				mPopup.miEdit->style = mPopup.miEdit->style & ~WS_DISABLED
				mPopup.miDelete->style = mPopup.miDelete->style & ~WS_DISABLED
				mPopup.miSetPaid->style = mPopup.miSetPaid->style & ~WS_DISABLED
				mPopup.miSetUnpaid->style = mPopup.miSetUnpaid->style & ~WS_DISABLED
				move cursor to Xwin, Ywin in wintask
				open mPopup
			}
		}
		break

	case == EV_SELECT:
		if (State) break
		/* Drop through to EV_UNSELALL */

	case == EV_UNSELALL:
		mPopup.miEdit->style = mPopup.miEdit->style | WS_DISABLED
		mPopup.miDelete->style = mPopup.miDelete->style | WS_DISABLED
		mPopup.miSetPaid->style = mPopup.miSetPaid->style | WS_DISABLED
		mPopup.miSetUnpaid->style = mPopup.miSetUnpaid->style | WS_DISABLED
		break
	}
}

/****************************************************************************/

!function evPrint(EventCode) {

	switch (EventCode) {

	case == EV_MENU:
		clear PRINT
		show WinPrint
		dialog WinPrint
		hide WinPrint
		break
	}
}

/****************************************************************************/

!function evSetPaid(EventCode) {
!temp Result,,i2

	switch (EventCode) {

	case == EV_MENU:
		if (tmp.DatePaid == 0) {
			tmp.DatePaid = sys.Date
		}
		display WinPaid
		show WinPaid
		dialog WinPaid
		hide WinPaid
		break
	}
}

/****************************************************************************/

!function evSetUnpaid(EventCode) {
!temp Result,,i2

	switch (EventCode) {

	case == EV_MENU:
		Result = table_first_selected_key(tblMileage)
		if (Result != OKAY) break

		fSetPromptPosn()

		prompt "Set selected claims unpaid? " \
				button=" Yes " button=" No  ", BREAK

		while (Result == OKAY) {
			read MILEAGE nsr=IGNORE
			MILEAGE.DatePaid = 0
			write MILEAGE nrs=IGNORE
			table_set_selected_key(tblMileage, FALSE)
			Result = table_next_selected_key(tblMileage)
		}

		display tblMileage
		break
	}
}

/****************************************************************************/

!function evWinTask(EventCode) {

	switch (EventCode) {

	case == EV_CLOSE:
		exit
	}
}

/*****************************************************************************
	Functions for WinEdit
*****************************************************************************/

!function evWinEdit(EventCode) {

	switch (EventCode) {

	case == EV_CLOSE:
		return CANCEL_DIALOG
	}
}

/****************************************************************************/

!function evWinEditCancel(EventCode) {

	switch (EventCode) {

	case == EV_BUTTON_CLICKED:
		tmp.WinEditCancelAll = FALSE
		return CANCEL_DIALOG
	}
}

/****************************************************************************/

!function evWinEditCancelAll(EventCode) {

	switch (EventCode) {

	case == EV_BUTTON_CLICKED:
		tmp.WinEditCancelAll = TRUE
		return CANCEL_DIALOG
	}
}

/****************************************************************************/

!function evWinEditSave(EventCode) {

	switch (EventCode) {

	case == EV_BUTTON_CLICKED:
		return CLOSE_DIALOG
	}
}

/*****************************************************************************
	Functions for WinPaid
*****************************************************************************/

!function evWinPaid(EventCode) {

	switch (EventCode) {

	case == EV_CLOSE:
		return CANCEL_DIALOG
	}
}

/****************************************************************************/

!function evWinPaidCancel(EventCode) {

	switch (EventCode) {

	case == EV_BUTTON_CLICKED:
		return CANCEL_DIALOG
	}
}

/****************************************************************************/

!function evWinPaidSetDate(EventCode) {
!temp Result,,i2

	switch (EventCode) {

	case == EV_BUTTON_CLICKED:
		Result = table_first_selected_key(tblMileage)

		while (Result == OKAY) {
			read MILEAGE nsr=IGNORE
			MILEAGE.DatePaid = tmp.DatePaid
			write MILEAGE nrs=IGNORE
			table_set_selected_key(tblMileage, FALSE)
			Result = table_next_selected_key(tblMileage)
		}

		display tblMileage
		return CLOSE_DIALOG
	}
}

/*****************************************************************************
	Functions for WinPrint
*****************************************************************************/

!function evWinPrint(EventCode) {

	switch (EventCode) {

	case == EV_CLOSE:
		return CANCEL_DIALOG
	}
}

/****************************************************************************/

!function evWinPrintClose(EventCode) {

	switch (EventCode) {

	case == EV_BUTTON_CLICKED:
		return CANCEL_DIALOG
	}
}

/****************************************************************************/

!function evWinPrintPreview(EventCode) {

	switch (EventCode) {

	case == EV_BUTTON_CLICKED:
		fPrintMileageClaims("V")
		break
	}
}

/****************************************************************************/

!function evWinPrintPrint(EventCode) {

	switch (EventCode) {

	case == EV_BUTTON_CLICKED:
		fPrintMileageClaims("P")
		break
	}
}

/*****************************************************************************
	Edit mileage claim
*****************************************************************************/

!function fEditMileage() {

	read MILEAGE nsr=IGNORE

	if (sys.Traps & TRAP_NSR) {
		table_set_selected_key(tblMileage, FALSE)
		display tblMileage
		return
	}

	WinEdit->title = "EDIT MILEAGE CLAIM"
	display WinEdit
	show WinEdit.bgControl.pbCancelAll
	show WinEdit

	while (TRUE) {
		dialog WinEdit cancel=EDIT_MILEAGE_CANCEL
		if (fWriteMileage() == OKAY) break
	}

	display tblMileage

EDIT_MILEAGE_CANCEL:
	unlock MILEAGE
	hide WinEdit
}

/*****************************************************************************
	Write updated mileage claim
*****************************************************************************/

!function fWriteMileage() {

	if (fCheckMileageRecord() == ERROR) return ERROR

	write MILEAGE nrs=IGNORE re=IGNORE
	if (sys.Traps == 0) return OKAY

	return fInsertMileageRecord()
}

/*****************************************************************************
	Insert new mileage claim
*****************************************************************************/

!function fInsertMileage() {

	if (fCheckMileageRecord() == ERROR) return ERROR

	return fInsertMileageRecord()
}

/****************************************************************************/

!function fCheckMileageRecord() {

	if (MILEAGE.StartDate == 0) {
		error "Start Date cannot be blank"
		return ERROR
	}

	if (MILEAGE.Mileage == 0) {
		error "Mileage cannot be blank"
		return ERROR
	}

	if (MILEAGE.EndDate == 0) {
		MILEAGE.EndDate = MILEAGE.StartDate
	}

	return OKAY
}

/****************************************************************************/

!function fInsertMileageRecord() {

	MILEAGE.SerialNo = 0

	while (TRUE) {
		insert MILEAGE re=IGNORE
		if (sys.Traps == 0) break
		MILEAGE.SerialNo++
		if (MILEAGE.SerialNo == 0) {
			error "Too many mileage claims on same date!"
			return ERROR
		}
	}

	return OKAY
}

/*****************************************************************************
	Print mileage claims
*****************************************************************************/

!function fPrintMileageClaims(Option) {

	SAVE_MILEAGE = MILEAGE

	/* Open file in read mode to take advantage of batch reads */
	openfile MILEAGE name=MILEAGE_PATH read

	if (Option = "V") {
		run report repPrintMileageClaims ppf="Arial"
	} else {
		run report repPrintMileageClaims to "PrintManager" ppf="Arial"
	}

	/* Reopen file in update mode */
	openfile MILEAGE name=MILEAGE_PATH update

	/* Reset the file position */
	MILEAGE = SAVE_MILEAGE
	readkey MILEAGE traps=IGNORE
}

/*****************************************************************************
	Set prompt window position
*****************************************************************************/

!function fSetPromptPosn() {

	winprompt->xcreate = wintask->xposn + 300
	winprompt->ycreate = wintask->yposn + 200
}

/*****************************************************************************
	Reports
*****************************************************************************/

!report repPrintMileageClaims {

!drive MILEAGE

/****************************************************************************/

!init {
	PRINT.TotalMileage = 0
	SAVE_MILEAGE = MILEAGE
	setfont("Arial", 8, FONT_NORMAL)
	sys.Gap = 1
	sys.LeftMargin = 6
	sys.LineHeight = sys.CharHeight
}

/****************************************************************************/

!heading {
	print	PSC_ENHANCED; PSC_UNDERLINE;

	print "MILEAGE CLAIMS";

	if (PRINT.StartDate) {
		print	" from "; PRINT.StartDate;
	}

	if (PRINT.EndDate) {
		print	" to "; PRINT.EndDate;
	}

	print	PSC_END_UNDERLINE; PSC_NORMAL; nsp(4); PSC_ENHANCED; \
			"(printed at "; sys.Time; " on "; sys.Date:"dD/MM/YYYY"; ")"; \
			PSC_NORMAL; nsp(4); \
			"Page: "; PSC_ENHANCED; tostr(sys.PageNumber); \
			PSC_NORMAL

	print

	printh	PSC_UNDERLINE; *MILEAGE.StartDate; PSC_END_UNDERLINE, \
			PSC_UNDERLINE; *MILEAGE.EndDate; PSC_END_UNDERLINE, \
			PSC_UNDERLINE; *MILEAGE.Cat; PSC_END_UNDERLINE, \
			PSC_UNDERLINE; *MILEAGE.RegNo; PSC_END_UNDERLINE, \
			PSC_UNDERLINE; *MILEAGE.Mileage; PSC_END_UNDERLINE, \
			PSC_UNDERLINE; *MILEAGE.DatePaid; PSC_END_UNDERLINE; spc(2); \
			PSC_UNDERLINE; *MILEAGE.Details; PSC_END_UNDERLINE

	print
}

/****************************************************************************/

!final {
	print
	print	tab(25); PSC_UNDERLINE; \
			"Total Mileage = "; tostr(PRINT.TotalMileage); \
			PSC_END_UNDERLINE
}

/****************************************************************************/

	if (PRINT.EndDate and MILEAGE.EndDate > PRINT.EndDate) end report

	if (PRINT.StartDate and MILEAGE.EndDate < PRINT.StartDate) end

	switch (MILEAGE.Cat) {
	case == "C":
		if not (WinPrint.cgCat.cbCars->selected) end
		break
	case == "M":
		if not (WinPrint.cgCat.cbMotorbikes->selected) end
		break
	case == "B":
		if not (WinPrint.cgCat.cbBicycles->selected) end
		break
	}

	switch (PRINT.Status) {
	case == "P":
		if (MILEAGE.DatePaid == 0) end
		break
	case == "U":
		if (MILEAGE.DatePaid) end
		break
	}

	need 3

	printh	MILEAGE.StartDate, \
			MILEAGE.EndDate, \
			MILEAGE.Cat, \
			MILEAGE.RegNo, \
			MILEAGE.Mileage, \
			MILEAGE.DatePaid; spc(2); \
			fit(MILEAGE.Details)

	PRINT.TotalMileage = PRINT.TotalMileage + MILEAGE.Mileage

	end
}

/****************************************************************************/
